/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package it.inaf.oats.ia2.tap.utils;

import it.inaf.oats.ia2.tap.utils.tapschema.Column;
import it.inaf.oats.ia2.tap.utils.tapschema.Schema;
import it.inaf.oats.ia2.tap.utils.tapschema.Table;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import org.apache.wicket.AttributeModifier;
import org.apache.wicket.ajax.AjaxEventBehavior;
import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.form.OnChangeAjaxBehavior;
import org.apache.wicket.behavior.AttributeAppender;
import org.apache.wicket.extensions.markup.html.repeater.data.grid.DataGridView;
import org.apache.wicket.markup.html.form.TextField;
import org.apache.wicket.markup.repeater.Item;
import org.apache.wicket.markup.repeater.RepeatingView;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.Model;

/**
 * AjaxTextField class extends TextField class to add an univocal ID (called idString) to it.
 * AjaxTextField class implements the onUpdate method of the OnChangeAjaxBehavior and
 * the onEvent method of the AjaxEventBehavior on the onfocusout event.
 * The onUpdate method of the OnChangeAjaxBehavior is needed to update the variables
 * of the data structure corresponding to every AjaxTextField.
 * The onEvent method of the AjaxEventBehavior on the onfocusout event is needed
 * to update the tooltip of the utype, ucd, unit and description AjaxTextFields.
 * 
 * @author pietro
 */
public class AjaxTextField extends TextField {
    
    private String idString;
    
    /**
     * AjaxTextField constructor
     * 
     * @param id
     * @param model 
     */
    public AjaxTextField(String id, IModel model)
    {
        super(id, model);
        
        OnChangeAjaxBehavior onChangeAjaxBehavior = new OnChangeAjaxBehavior()
        {
            /**
             * The onUpdate method of the OnChangeAjaxBehavior updates the correct
             * variable of the data structure on the base of the idString path
             * when the user inserts a new character in the corresponding
             * AjaxTextField.
             * 
             * @param target
             */
            @Override
            protected void onUpdate(AjaxRequestTarget target)
            {
                SchemaPage schemaPage = (SchemaPage)getPage();
                String[] idSplit = getIdString().split("-");
                if (idSplit.length == 2) //if schema TextField
                {
                    //gets current SchemaPanel
                    SchemaPanelOld schemaPanel =
                            (SchemaPanelOld)schemaPage.schemataTabbedPanel
                            .get("panel");
                    
                    //sets selectSchemaCheckBox
                    schemaPanel.selectSchemaCheckBox.setModelObject(true);
                    String[] idSplit2 = schemaPanel.selectSchemaCheckBox.getIdString().split("-");
                    if (idSplit2[1].equals("checked"))
                    {
                        schemaPage.tapschema.schemasMap.get(idSplit2[0])
                                .checked
                                = (boolean)schemaPanel.selectSchemaCheckBox.getModelObject();
                    }                                                        
                    target.add(schemaPanel.selectSchemaCheckBox);
                    //end setting selectSchemaCheckBox
                    
                    //sets variable "checked" in the correct schema of tapschema structure
                    for (Schema schema : schemaPage.tapschema.schemasMap.values())
                    {
                        if (schema.schema_name.equals(
                                schemaPage.tapschema.schemasMap.get(idSplit[0]).schema_name))
                        {
                            schema.checked = true;
                        }
                    }
                    //end setting variable "checked"
                    
                    //sets variables "utype" and "description" in the correct schema of tapschema structure 
                    if (idSplit[1].equals("utype"))
                    {
                        schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .setUtype((String)getModelObject());
                    }
                    else if (idSplit[1].equals("description"))
                    {
                        schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .setDescription((String)getModelObject());
                    }
                    //end setting variables "utype" and "description"
                }
                else if (idSplit.length == 3) //if table TextField
                {
                    //gets current SchemaPanel and TablePanel
                    SchemaPanelOld schemaPanel =
                            (SchemaPanelOld)schemaPage.schemataTabbedPanel
                            .get("panel");
                    TablePanel tablePanel =
                            (TablePanel)schemaPanel.tablesTabbedPanel
                            .get("panel");
                    
                    //sets selectTableCheckBox
                    tablePanel.selectTableCheckBox.setModelObject(true);
                    String[] idSplit2 = tablePanel.selectTableCheckBox.getIdString().split("-");
                    if (idSplit2[2].equals("checked"))
                    {
                        schemaPage.tapschema.schemasMap.get(idSplit2[0])
                                .tablesMap.get(idSplit2[1])
                                .checked
                                = (boolean)tablePanel.selectTableCheckBox.getModelObject();
                    }
                    target.add(tablePanel.selectTableCheckBox);
                    //end setting selectTableCheckBox

                    //sets selectSchemaCheckBox
                    schemaPanel.selectSchemaCheckBox.setModelObject(true);
                    idSplit2 = schemaPanel.selectSchemaCheckBox.getIdString().split("-");
                    if (idSplit2[1].equals("checked"))
                    {
                        schemaPage.tapschema.schemasMap.get(idSplit2[0])
                                .checked
                                = (boolean)schemaPanel.selectSchemaCheckBox.getModelObject();
                    }                                                        
                    target.add(schemaPanel.selectSchemaCheckBox);
                    //end setting selectSchemaCheckBox
                    
                    //sets variable "checked" in the correct schema of tapschema structure
                    for (Schema schema : schemaPage.tapschema.schemasMap.values())
                    {
                        if (schema.schema_name.equals(
                                schemaPage.tapschema.schemasMap.get(idSplit[0]).schema_name))
                        {
                            schema.checked = true;
                        }
                    }
                    //end setting variable "checked"
                    
                    //sets variable "checked" in the correct table of tapschema structure
                    for (Table table : schemaPage.tapschema.schemasMap.get(idSplit[0])
                            .tablesMap.values())
                    {
                        if (table.table_name.equals(
                                schemaPage.tapschema.schemasMap.get(idSplit[0]).
                                tablesMap.get(idSplit[1]).table_name))
                        {
                            table.checked = true;
                        }
                    }
                    //end setting variable "checked"
                    
                    //sets variables "utype" and "description" in the correct table of tapschema structure
                    if (idSplit[2].equals("utype"))
                    {
                        schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .tablesMap.get(idSplit[1])
                                .setUtype((String)getModelObject());
                    }
                    else if (idSplit[2].equals("description"))
                    {
                        schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .tablesMap.get(idSplit[1])
                                .setDescription((String)getModelObject());
                        
                    }
                    //end setting variables "utype" and "description"
                }
                else if (idSplit.length == 4) //if DataGridView TextField
                {
                    //sets row CheckBox
                    List<Column> columnsList = new ArrayList<Column>();
                    for (Column column : schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .tablesMap.get(idSplit[1])
                                .getColumns())
                    {
                        columnsList.add(column);
                    }
                    int columnIndex = 0;
                    for (int i = 0; i < columnsList.size(); i++)
                    {
                        if (columnsList.get(i).getColumnName().equals(schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .tablesMap.get(idSplit[1])
                                .getColumn(idSplit[2]).getColumnName()))
                        {
                            columnIndex = i;
                            break;
                        }
                    }
                    
                    //gets current SchemaPanel, TablePanel, DataGridView
                    SchemaPanelOld schemaPanel =
                            (SchemaPanelOld)schemaPage.schemataTabbedPanel
                            .get("panel");
                    TablePanel tablePanel =
                            (TablePanel)schemaPanel.tablesTabbedPanel
                            .get("panel");
                    DataGridView<Row> rows =
                            (DataGridView<Row>)tablePanel.get("updateTableForm").get("rows");
                    
                    Iterator iterator = rows.getItems();
                    List<Item> itemList = new ArrayList<Item>();
                    while (iterator.hasNext())
                    {
                        itemList.add((Item)iterator.next());
                    }
                    for (Item item : itemList)
                    {
                        if (item.getIndex() == columnIndex)
                        {
                            //AjaxCheckBox cell2 = (AjaxCheckBox)item.get("cell2");
                            //AjaxCheckBox cell2 = (AjaxCheckBox)item.get(0).get("cell2");
                            RepeatingView cells = (RepeatingView)item.get("cells");
                            AjaxCheckBox cell2 = (AjaxCheckBox)cells.get(0).get("cell2");
                            cell2.setModelObject(true);
                            target.add(cell2);
                            
                            //sets selectTableCheckBox
                            tablePanel.selectTableCheckBox.setModelObject(true);
                            String[] idSplit2 = tablePanel.selectTableCheckBox.getIdString().split("-");
                            if (idSplit2[2].equals("checked"))
                            {
                                schemaPage.tapschema.schemasMap.get(idSplit2[0])
                                        .tablesMap.get(idSplit2[1])
                                        .checked
                                        = (boolean)tablePanel.selectTableCheckBox.getModelObject();
                            }
                            target.add(tablePanel.selectTableCheckBox);
                            //end set selectTableCheckBox
                            
                            //sets selectSchemaCheckBox
                            schemaPanel.selectSchemaCheckBox.setModelObject(true);
                            idSplit2 = schemaPanel.selectSchemaCheckBox.getIdString().split("-");
                            if (idSplit2[1].equals("checked"))
                            {
                                schemaPage.tapschema.schemasMap.get(idSplit2[0])
                                        .checked
                                        = (boolean)schemaPanel.selectSchemaCheckBox.getModelObject();
                            }                                                        
                            target.add(schemaPanel.selectSchemaCheckBox);
                            //end setting selectSchemaCheckBox
                            
                            break;
                        }
                    }
                    //end setting row CheckBox
                    
                    //sets variable "checked" in the correct schema of tapschema structure
                    for (Schema schema : schemaPage.tapschema.schemasMap.values())
                    {
                        if (schema.schema_name.equals(
                                schemaPage.tapschema.schemasMap.get(idSplit[0]).schema_name))
                        {
                            schema.checked = true;
                        }
                    }
                    //end setting variable "checked"
                    
                    //sets variable "checked" in the correct table of tapschema structure
                    for (Table table : schemaPage.tapschema.schemasMap.get(idSplit[0])
                            .tablesMap.values())
                    {
                        if (table.table_name.equals(
                                schemaPage.tapschema.schemasMap.get(idSplit[0]).
                                tablesMap.get(idSplit[1]).table_name))
                        {
                            table.checked = true;
                        }
                    }
                    //end setting variable "checked"
                    
                    //sets variable "checked" in the correct column of tapschema structure
                    for (Column column : schemaPage.tapschema.schemasMap.get(idSplit[0])
                            .tablesMap.get(idSplit[1])
                            .getColumns())
                    {
                        if (column.getColumnName().equals(schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .tablesMap.get(idSplit[1])
                                .getColumn(idSplit[2])
                                .getColumnName()))
                        {
                            column.checked = true;
                        }
                    }
                    //end setting variable "checked"
                    /*
                    //get cells of index item, needed to set tooltips
                    RepeatingView cells = null;
                    for (Item item : itemList)
                    {
                        if (item.getIndex() == columnIndex)
                        {
                            cells = (RepeatingView)item.get("cells");
                        }
                    }
                    */
                    //sets variables in the correct column of tapschema structure
                    if (idSplit[3].equals("table_name"))
                    {
                        schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .tablesMap.get(idSplit[1])
                                .getColumn(idSplit[2])
                                .setTableName((String)getModelObject());
                    }
                    else if (idSplit[3].equals("column_name"))
                    {
                        schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .tablesMap.get(idSplit[1])
                                .getColumn(idSplit[2])
                                .setColumnName((String)getModelObject());
                    }
                    else if (idSplit[3].equals("utype"))
                    {
                        schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .tablesMap.get(idSplit[1])
                                .getColumn(idSplit[2])
                                .setUtype((String)getModelObject());
                        /*
                        //update tooltip
                        AjaxTextField cell = (AjaxTextField)cells.get(5).get("cell");
                        String modelObject = (String)getModelObject();
                        cell.add(AttributeModifier.replace("title", new Model(modelObject)));                       
                        target.add(cell);
                        */
                        /*
                        target.appendJavaScript("{ var el=wicketGet('" + cell.getMarkupId() + "');" + 
                                " el.select(); " + 
                                        " }"); 
                        target.focusComponent(cell);
                        */
                        /*
                        target.appendJavaScript("{ " +
                                cell + ".focus();" +
                                cell + ".value += '';" +
                                " }");
                        //target.focusComponent(cell);
                        */
                    }
                    else if (idSplit[3].equals("ucd"))
                    {
                        schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .tablesMap.get(idSplit[1])
                                .getColumn(idSplit[2])
                                .setUcd((String)getModelObject());
                        /*
                        //update tooltip
                        AjaxTextField cell = (AjaxTextField)cells.get(6).get("cell");
                        String modelObject = (String)getModelObject();
                        cell.add(AttributeModifier.replace("title", new Model(modelObject)));                       
                        target.add(cell);
                        */
                    }
                    else if (idSplit[3].equals("unit"))
                    {
                        schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .tablesMap.get(idSplit[1])
                                .getColumn(idSplit[2])
                                .setUcd((String)getModelObject());
                        /*
                        //update tooltip
                        AjaxTextField cell = (AjaxTextField)cells.get(7).get("cell");
                        String modelObject = (String)getModelObject();
                        cell.add(AttributeModifier.replace("title", new Model(modelObject)));                       
                        target.add(cell);
                        */
                    }
                    else if (idSplit[3].equals("description"))
                    {
                        schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .tablesMap.get(idSplit[1])
                                .getColumn(idSplit[2])
                                .setDescription((String)getModelObject());
                        /*
                        //update tooltip
                        AjaxTextField cell = (AjaxTextField)cells.get(8).get("cell");
                        String modelObject = (String)getModelObject();
                        cell.add(AttributeModifier.replace("title", new Model(modelObject)));                       
                        target.add(cell);
                        */
                    }
                    else if (idSplit[3].equals("datatype"))
                    {
                        schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .tablesMap.get(idSplit[1])
                                .getColumn(idSplit[2])
                                .setDatatype((String)getModelObject());
                    }
                    else if (idSplit[3].equals("size"))
                    {
                        schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .tablesMap.get(idSplit[1])
                                .getColumn(idSplit[2])
                                .setSize((Integer)getModelObject());
                    }
                    else if (idSplit[3].equals("principal"))
                    {
                        schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .tablesMap.get(idSplit[1])
                                .getColumn(idSplit[2])
                                .setPrincipal((Integer)getModelObject());
                    }
                    else if (idSplit[3].equals("indexed"))
                    {
                        schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .tablesMap.get(idSplit[1])
                                .getColumn(idSplit[2])
                                .setIndexed((Integer)getModelObject());
                    }
                    else if (idSplit[3].equals("std"))
                    {
                        schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .tablesMap.get(idSplit[1])
                                .getColumn(idSplit[2])
                                .setStd((Integer)getModelObject());
                    }
                    //end setting variables
                } //if length
            } //end onUpdate
        };
        add(onChangeAjaxBehavior);
        
        AjaxEventBehavior ajaxEventBehavior = new AjaxEventBehavior("onfocusout")
        {
            /**
             * The onEvent method of the AjaxEventBehavior on the onfocusout event
             * updates the tooltip of the correct AjaxTextField on the base of the
             * idString path when this AjaxTextField loses focus.
             * 
             * @param target
             */
            @Override
            protected void onEvent(AjaxRequestTarget target)
            {
                SchemaPage schemaPage = (SchemaPage)getPage();
                String[] idSplit = getIdString().split("-");
                    
                if (idSplit.length == 4) //if DataGridView TextField
                {
                    //sets row CheckBox
                    List<Column> columnsList = new ArrayList<Column>();
                    for (Column column : schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .tablesMap.get(idSplit[1])
                                .getColumns())
                    {
                        columnsList.add(column);
                    }
                    int columnIndex = 0;
                    for (int i = 0; i < columnsList.size(); i++)
                    {
                        if (columnsList.get(i).getColumnName().equals(schemaPage.tapschema.schemasMap.get(idSplit[0])
                                .tablesMap.get(idSplit[1])
                                .getColumn(idSplit[2]).getColumnName()))
                        {
                            columnIndex = i;
                            break;
                        }
                    }
                    
                    //gets current SchemaPanel, TablePanel, DataGridView
                    SchemaPanelOld schemaPanel =
                            (SchemaPanelOld)schemaPage.schemataTabbedPanel
                            .get("panel");
                    TablePanel tablePanel =
                            (TablePanel)schemaPanel.tablesTabbedPanel
                            .get("panel");
                    DataGridView<Row> rows =
                            (DataGridView<Row>)tablePanel.get("updateTableForm").get("rows");
                    
                    Iterator iterator = rows.getItems();
                    List<Item> itemList = new ArrayList<Item>();
                    while (iterator.hasNext())
                    {
                        itemList.add((Item)iterator.next());
                    }
                    for (Item item : itemList)
                    {
                        if (item.getIndex() == columnIndex)
                        {
                            //gets cells of index item, needed to set tooltips
                            RepeatingView cells = (RepeatingView)item.get("cells");
                   
                            if (idSplit[3].equals("utype"))
                            {
                                AjaxTextField cell = (AjaxTextField)cells.get(5).get("cell");
                                String modelObject = (String)getModelObject();
                                cell.add(AttributeModifier.replace("title", new Model(modelObject)));                       
                                target.add(cell);
                            }
                            else if (idSplit[3].equals("ucd"))
                            {
                                AjaxTextField cell = (AjaxTextField)cells.get(6).get("cell");
                                String modelObject = (String)getModelObject();
                                cell.add(AttributeModifier.replace("title", new Model(modelObject)));                       
                                target.add(cell);
                            }
                            else if (idSplit[3].equals("unit"))
                            {
                                AjaxTextField cell = (AjaxTextField)cells.get(7).get("cell");
                                String modelObject = (String)getModelObject();
                                cell.add(AttributeModifier.replace("title", new Model(modelObject)));                       
                                target.add(cell);
                            }
                            else if (idSplit[3].equals("description"))
                            {
                                AjaxTextField cell = (AjaxTextField)cells.get(8).get("cell");
                                String modelObject = (String)getModelObject();
                                cell.add(AttributeModifier.replace("title", new Model(modelObject)));                       
                                target.add(cell);
                            }
                        }
                    }
                    
                    
                }
            }
        };
        add(ajaxEventBehavior);
        
    }
        
    public String getIdString()
    {
        return idString;
    }
    
    public void setIdString(String idString)
    {
        this.idString = idString;
    }
    
}
