package it.inaf.oats.ia2.tap.utils.tapschema;

import java.io.Serializable;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author pietro
 */
public class Table implements Serializable {

    public String schema_name;
    public String table_name;
    public String table_type;
    private String utype;
    private String description;
    //public List<Column> columnsList = new ArrayList<Column>();
    private final Map<String, Column> columnsMap;

    public boolean checked;

    public Table() {
        columnsMap = new HashMap<String, Column>();
    }

    public Map<String, Column> getColumnsMap() {
        return columnsMap;
    }

    public void addColumn(String key, Column column) {
        columnsMap.put(key, column);
    }

    public Collection<Column> getColumns() {
        return columnsMap.values();
    }

    public Column getColumn(String columnName) {
        return columnsMap.get(columnName);
    }

    public String getUtype() {
        return utype;
    }

    public void setUtype(String utype) {
        this.utype = utype;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }
}
